#!/usr/bin/python
# -*- coding: UTF-8 -*-


############################################################################
##                                                                        ##
## Zapette                                                                ##
##                                                                        ##
## Copyright (C) 2012  Fabien Loison <flo AT flogisoft DOT com>           ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################


from os import popen

import gtk, pygtk
pygtk.require("2.0")

from zapette.providers.freebox import FreeboxProvider


PLAYER = "/usr/bin/vlc"
CHANS = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
        118, 119, 123, 126, 25, 46]


class GUI(object):
    """Demo GUI for Freebox TV."""
    def __init__(self):
        """The contructor."""
        #Window
        self.win = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.set_title("[Demo] Freebox TV - Zapette")
        self.win.connect("destroy", gtk.main_quit)

        #Table
        self.tab = gtk.Table(homogeneous=True)
        self.win.add(self.tab)

        #Buttons
        i = 0
        for chan in CHANS:
            channel = tv.get_channel_by_id(chan)
            if channel:
                btn = gtk.Button(channel.name)
                x = i % 3
                y = i / 3
                self.tab.attach(btn, x, x+1, y, y+1)
                btn.connect("clicked", self.play, channel.chan_id)
                i += 1

        #Display the window
        self.win.show_all()

    def play(self, widget, chan_id):
        """Play the selected channel."""
        channel = tv.get_channel_by_id(chan_id)
        stream = ""
        if "HD" in channel.streams:
            stream = "HD"
        elif "standard" in channel.streams:
            stream = "standard"
        elif "bas débit" in channel.streams:
            stream = "bas débit"
        elif "TNT" in channel.streams:
            stream = "TNT"
        elif "TNT HD" in channel.streams:
            stream = "TNT HD"
        elif "auto" in channel.streams:
            stream = "auto"
        popen("%s '%s' &" % (PLAYER, channel.streams[stream]))


if __name__ == "__main__":
    tv = FreeboxProvider()
    gui = GUI()
    gtk.main()
