#!/usr/bin/python
# -*- coding: UTF-8 -*-


"""Freebox TV module for Zapette."""


from urllib import urlopen
from re import match

from zapette.tv import TvProvider, TvChannel


class FreeboxProvider(TvProvider):
    """Freebox TV provider."""

    _playlist_url = "http://mafreebox.freebox.fr/freeboxtv/playlist.m3u"

    def _load_playlist(self):
        """Load the channel DB from the playlist."""
        chan_id = -1
        chan_name = ""
        chan_qual = ""
        playlist = urlopen(self._playlist_url)
        for line in playlist:
            if line.startswith("#EXTINF:"):
                if match(r"^#EXTINF:0,([0-9]+)\s-\s(.+)\s\((.+)\)$", line):
                    chan_id = int(match(r"^#EXTINF:0,([0-9]+)\s-\s(.+)\s\((.+)\)$", line).group(1))
                    chan_name = match(r"^#EXTINF:0,([0-9]+)\s-\s(.+)\s\((.+)\)$", line).group(2)
                    chan_qual = match(r"^#EXTINF:0,([0-9]+)\s-\s(.+)\s\((.+)\)$", line).group(3)
                    #Fixe the name TNT HD streams
                    if chan_name.endswith(" HD") and chan_qual == "TNT":
                        chan_name = chan_name[:-3]
                        chan_qual = "TNT HD"
                    if chan_name.endswith("HD") and chan_qual == "TNT":
                        chan_name = chan_name[:-2]
                        chan_qual = "TNT HD"
                else:
                    chan_id = -1
                    chan_name = ""
                    chan_qual = ""
            elif line.startswith("rtsp://") and chan_id > -1:
                if self.get_channel_by_id(chan_id):
                    self.get_channel_by_id(chan_id).streams[chan_qual] = line[:-1]
                else:
                    channel = TvChannel()
                    channel.chan_id = chan_id
                    channel.name = chan_name
                    channel.streams = {chan_qual: line[:-1]}
                    self._channels.append(channel)
